Unidirectional TSP(dp)

Description

Background

Problems that require minimum paths through some domain appear in many different areas of computer science. For example, one of the constraints in VLSI routing problems is minimizing wire length. The Traveling
Salesperson Problem (TSP) -- finding whether all the cities in a salesperson‘s route can be visited exactly once with a specified limit on travel time -- is one of the canonical examples of an NP-complete problem; solutions appear to require an inordinate
amount of time to generate, but are simple to check.

This problem deals with finding a minimal path through a grid of points while traveling only from left to right.

The Problem

Given an  matrix of integers, you are to write a program
that computes a path of minimal weight. A path starts anywhere in column 1 (the first column) and consists of a sequence of steps terminating in column n (the last column). A step consists of traveling from columni to column i+1
in an adjacent (horizontal or diagonal) row. The first and last rows (rows 1 and m) of a matrix are considered adjacent, i.e., the matrix ``wraps‘‘ so that it represents a horizontal cylinder. Legal steps are illustrated below.

The weight of a path is the sum of the integers in each of the n cells of the matrix that are visited.

For example, two slightly different  matrices are shown below
(the only difference is the numbers in the bottom row).

The minimal path is illustrated for each matrix. Note that the path for the matrix on the right takes advantage of the adjacency property of the first and last rows.

The Input

The input consists of a sequence of matrix specifications. Each matrix specification consists of the row and column dimensions in that order on a line followed by  integers
where m is the row dimension and n is the column dimension. The integers appear in the input in row major order, i.e., the first n integers constitute the first row of the matrix, the second n integers constitute the second
row and so on. The integers on a line will be separated from other integers by one or more spaces. Note: integers are not restricted to being positive. There will be one or more matrix specifications in an input file. Input is terminated by end-of-file.

For each specification the number of rows will be between 1 and 10 inclusive; the number of columns will be between 1 and 100 inclusive. No path‘s weight will exceed integer values representable using 30 bits.

The Output

Two lines should be output for each matrix specification in the input file, the first line represents a minimal-weight path, and the second line is the cost of a minimal path. The path consists of a sequence
of n integers (separated by one or more spaces) representing the rows that constitute the minimal path. If there is more than one path of minimal weight the path that is lexicographically smallest should be output.

Sample Input

5 6
3 4 1 2 8 6
6 1 8 2 7 4
5 9 3 9 9 5
8 4 1 3 2 6
3 7 2 8 6 4
5 6
3 4 1 2 8 6
6 1 8 2 7 4
5 9 3 9 9 5
8 4 1 3 2 6
3 7 2 1 2 3
2 2
9 10 9 10

Sample Output

1 2 3 4 4 5
16
1 2 1 5 4 5
11
1 1
19

题目大意:

给你一个n * m的矩阵,每个矩阵的元素都有相应的值,找出一条路径,从一列的任意一点出发走到底m列的任意一点出去,可以走的三个方向如图所示,当在第一行时,往右上角走的话可以最直走到第n行(在第n行往右下走的时候同理)。走到最后求出值最小的一个路径每次所在行,要求输出字典序最小的一条路。

解题思路:

运用数字三角形的思想可以一直从前往后每个点都加上前一列能走到该点的最小值,然后一直到最后一行。这种方法到求字典序最小的路径的时候异常麻烦,自己没写出来,所以换一种思想,从最后一列一直加到第一列,每次存取字典序最小的方案,然后求出解。

代码如下:

#include<iostream>
#include<cstdio>
#include<map>
#include<math.h>
#include<cstring>
#include<algorithm>
using namespace std;

int main()
{
    int i, j,vis[20][110], m, n;
    int dp[20][110], Map[20][110];
    while(scanf("%d%d",&m,&n) != EOF)
    {
        memset(Map,0,sizeof(Map));
        memset(dp,0,sizeof(dp));
        for(i = 1; i <= m; i++)
        {
            for(j = 1; j <= n; j++)
            {
                scanf("%d",&Map[i][j]);
            }
        }

        for(i = n; i >= 1; i--)
        {
            for(j = 1 ; j <= m; j++)
            {
                dp[j][i] = Map[j][i] +  dp[j][i + 1];//先加上往前走的
                vis[j][i] = j;    // vis数组保存每次的路径
                if(j > 1 && (dp[j][i] >= Map[j][i] + dp[j - 1][i + 1])) //如果王右上走小于等于当前值都要更新,因为字典序较小
                {
                       dp[j][i] = Map[j][i] + dp[j - 1][i + 1];
                       vis[j][i] = j - 1;
                }
                if(j == m && (dp[j][i] >= Map[j][i] + dp[1][i +1]))//同理字典序最小要更新。
                {
                       dp[j][i] = Map[j][i] + dp[1][i + 1];
                       vis[j][i] = 1;
                }
                if(j < m && (dp[j][i] > Map[j][i] + dp[j + 1][i + 1]))//只能先判断这一个,因为如果先判断下面的j == 1的话字典序有一种情况不是最优
                {
                       dp[j][i] = Map[j][i] + dp[j + 1][i +1];
                       vis[j][i] = j + 1;
                }
                if(j == 1 && (dp[j][i] > Map[j][i] +dp[m][i + 1]))
                {
                       dp[j][i] = Map[j][i] + dp[m][i + 1];
                       vis[j][i] = m;
                }

            }
        }
        int besti;
        int minx;
        besti = 1;//找到最优的方案
        for(i = 2; i <= m; i++)
        {
            if(dp[i][1] < dp[besti][1])
            {
                besti = i;
            }
        }
        printf("%d",besti);
        minx = dp[besti][1];
        //依次往下找就出来了
        for(i = 1; i < n; i++)
        {
            printf(" %d",vis[besti][i]);
            besti = vis[besti][i];
        }
        printf("\n");
        printf("%d\n",minx);
    }
    return 0;
}
时间: 2024-10-11 03:27:01

Unidirectional TSP(dp)的相关文章

uva 116 Unidirectional TSP (DP)

uva 116 Unidirectional TSP Background Problems that require minimum paths through some domain appear in many different areas of computer science. For example, one of the constraints in VLSI routing problems is minimizing wire length. The Traveling Sa

116 - Unidirectional TSP(DP)

多段图的最短路问题 .  运用了很多的技巧 :如 记录字典序最小路径 . 细节参见代码: #include<bits/stdc++.h> using namespace std; const int INF = 2000000000; int m,n,a[15][105],d[15][105],next_[15][105]; int main() { while(~scanf("%d%d",&m,&n)) { for(int i=0;i<m;i++)

hdu 5623 KK&#39;s Number(dp)

问题描述 我们可爱的KK有一个有趣的数学游戏:这个游戏需要两个人,有N\left(1\leq N\leq 5*{10}^{4} \right)N(1≤N≤5∗10?4??)个数,每次KK都会先拿数.每次可以拿任意多个数,直到NN个数被拿完.每次获得的得分为取的数中的最小值,KK和对手的策略都是尽可能使得自己的得分减去对手的得分更大.在这样的情况下,最终KK的得分减去对手的得分会是多少? 输入描述 第一行一个数T\left( 1\leq T\leq 10\right)T(1≤T≤10),表示数据组

Ural 1353 Milliard Vasya&#39;s Function(DP)

题目地址:Ural 1353 定义dp[i][j],表示当前位数为i位时,各位数和为j的个数. 对于第i位数来说,总可以看成在前i-1位后面加上一个0~9,所以状态转移方程就很容易出来了: dp[i][j]=dp[i][j]+dp[i][j-1]+dp[i][j-2]+.......+dp[i][j-9]: 最后统计即可. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <

HDU 4908 (杭电 BC #3 1002题)BestCoder Sequence(DP)

题目地址:HDU 4908 这个题是从m开始,分别往前DP和往后DP,如果比m大,就比前面+1,反之-1.这样的话,为0的点就可以与m这个数匹配成一个子串,然后左边和右边的相反数的也可以互相匹配成一个子串,然后互相的乘积最后再加上就行了.因为加入最终两边的互相匹配了,那就说明左右两边一定是偶数个,加上m就一定是奇数个,这奇数个的问题就不用担心了. 代码如下: #include <iostream> #include <stdio.h> #include <string.h&g

Sicily 1146:Lenny&#39;s Lucky Lotto(dp)

题意:给出N,M,问有多少个长度为N的整数序列,满足所有数都在[1,M]内,并且每一个数至少是前一个数的两倍.例如给出N=4, M=10, 则有4个长度为4的整数序列满足条件: [1, 2, 4, 8], [1, 2, 4, 9], [1, 2, 4, 10], [1, 2, 5, 10] 分析:可用动态规划解题,假设dp[i][j],代表满足以整数i为尾数,长度为j的序列的个数(其中每一个数至少是前一个数的两倍).那么对于整数i,dp[i][j] 等于所有dp[k][j-1]的和,其中k满足:

UVA542 - France &#39;98(dp)

UVA542 - France '98(dp) 题目链接 题目大意:之前题目意思还以为看懂了,其实没看明白,它已经把各个选手分在各自所在的区域里面,这就意味着第一次的PK的分组已经确定,而且冠军必须是从两个左右分区出来的胜利者才有机会pk冠军. 解题思路:那么从1-16这个大的区间内诞生出来的冠军可能是来自左边,也可能是右边,然后再左边右边的子区间递归找出冠军.f[i][l][r]表示l-r这个区间的胜利者是i的概率,那么假设i在区间的最左边,f[i][l][r] = Sum(f[i][l][m

HDU 4968 Improving the GPA(dp)

HDU 4968 Improving the GPA 题目链接 dp,最大最小分别dp一次,dp[i][j]表示第i个人,还有j分的情况,分数可以减掉60最为状态 代码: #include <cstdio> #include <cstring> #include <algorithm> using namespace std; int t, avg, n; double dp1[15][405], dp2[15][405]; double get(int x) { if

URAL 1167. Bicolored Horses (DP)

题目链接 题意 :农夫每天都会放马出去,然后晚上把马赶入马厩,于是让马排成一行入马厩,但是不想马走更多的路,所以让前p1匹入第一个马厩,p2匹马入第二个马厩…………但是他不想让他的任何一个马厩空着,所有的马都必须入马厩.有两种颜色的马,如果 i 匹黑马与 j 匹白马同在一个马厩,不愉快系数是 i * j,总系数就是k个系数相加.让总系数最小. 思路 : dp[i][j] 代表的是前 i 个马厩放 j 匹马的最小不愉快系数值. 1 //1167 2 #include <cstdio> 3 #in